module Text.Safe.LDAP
    ( LDAP, ldap, renderLDAP, module Text.Safe.Strings )
where

import Text.Safe.Strings

{-
 * A space or "#" character occurring at the beginning of the string
 * A space character occurring at the end of the string
 * One of the characters ",", "+", """, "\", "<", ">" or ";" 
 -}
--escapeLDAP (' ':xs) = ('\\':' ':escapeLDAP xs)
--escapeLDAP ('#':xs) = ('\\':'#':escapeLDAP xs)
escapeLDAP xs =
    concatMap esc xs
  where
    esc x | ldapReserved x = ['\\',x]
          | otherwise = [x]
ldapReserved = (`elem` ",+\"\\<>;")

$(declareSafeString "ldap" "LDAP" [| escapeLDAP |])
